#!/usr/bin/env python
# -*- coding: ASCII -*-

"""

:Author: Martin Kircher
:Contact: mkircher@uw.edu
:Date: *06.07.2013
"""

import sys, os
from optparse import OptionParser

parser = OptionParser("%prog [options]")
parser.add_option("--noheader", dest="noheader", help="Do not print header",default=False,action="store_true")
parser.add_option("--PHRED", dest="PHRED", help="File is already PHRED-scaled",default=False,action="store_true")
parser.add_option("-a","--all", dest="all", help="Report all annotation lines of variant with max score",default=False,action="store_true")
(options, args) = parser.parse_args()

if options.PHRED:
  scorecol = -2
else:
  scorecol = -1

fVconseq = 12
annolines = [(None,None),(None,None),(None,None),(None,None)]
all_lines = []

lpos,maxline,maxscore = None,None,None
GPSvalues = ["NA"]
firstval,lastval = 109,113

for line in sys.stdin:
  if line.startswith('#'):
    fields = line.rstrip().split("\t")
    for ind,value in enumerate(fields):
      if value == "Grantham": firstval = ind
      elif value == "SIFTval": lastval = ind+1
    if options.noheader: continue
    sys.stdout.write(line)
  else:
    fields = line.rstrip().split('\t')
    score = float(fields[scorecol])
    pos = tuple(fields[:5])

    if lpos != pos:
      if not options.all:
        for maxscore,maxline in annolines:
          if maxscore != None:
            if (maxline[firstval] == "NA") and (GPSvalues[0] != "NA"):
              maxline = maxline[:firstval]+GPSvalues+maxline[lastval:]
            sys.stdout.write("\t".join(maxline)+"\n")
            break
      else:
        if lpos != None:
          replace = None
          for maxscore,maxline in annolines:
            if maxscore != None: replace = maxline[lastval:]
          for linefields in all_lines:
            sys.stdout.write("\t".join(linefields[:lastval]+replace)+"\n")
          all_lines = []
        
      GPSvalues = fields[firstval:lastval]
      annolines = [(None,None),(None,None),(None,None),(None,None)]
      lpos = pos

    if ("coding" in fields[fVconseq]) or ("missense" in fields[fVconseq]) or ("synonymous" in fields[fVconseq]) or ("stop" in fields[fVconseq]) or ("mature" in fields[fVconseq]) or ("splice" in fields[fVconseq]) or ("initiator_codon" in fields[fVconseq]) or ("frame" in fields[fVconseq]) or ("terminal_codon" in fields[fVconseq]) or ("frame" in fields[fVconseq]):
      if annolines[0][0] == None or score > annolines[0][0]:
        annolines[0]=score,fields
    elif ("utr" in fields[fVconseq]) or ("regulatory" in fields[fVconseq]):
      if annolines[1][0] == None or score > annolines[1][0]:
        annolines[1]=score,fields
    elif "intronic" in fields[fVconseq] or ("upstream" in fields[fVconseq]) or ("downstream" in fields[fVconseq]):
      if annolines[2][0] == None or score > annolines[2][0]:
        annolines[2]=score,fields
    else:
      if annolines[3][0] == None or score > annolines[3][0]:
        annolines[3]=score,fields

    if (GPSvalues[0] == "NA") and (fields[firstval] != "NA"):
      GPSvalues = fields[firstval:lastval]

    if options.all:
      all_lines.append(fields)

if not options.all:
  for maxscore,maxline in annolines:
    if maxscore != None:
      if (maxline[firstval] == "NA") and (GPSvalues[0] != "NA"):
        maxline = maxline[:firstval]+GPSvalues+maxline[lastval:]
      sys.stdout.write("\t".join(maxline)+"\n")
      break
else:
  if lpos != None:
    replace = None
    for maxscore,maxline in annolines:
      if maxscore != None: replace = maxline[lastval:]
    for linefields in all_lines:
      sys.stdout.write("\t".join(linefields[:lastval]+replace)+"\n")
    all_lines = []
